import 'package:verttice_logic/verttice_logic.dart';
import "package:flutter/material.dart";
import 'package:verttice_ui/verttice_ui.dart';

class PropertytPrefixFormFactory extends StatefulWidget {
  final Function(String name, dynamic value) onChanged;
  final String displayName;
  final String name;
  final dynamic value;
  final dynamic restOfAddress;
  final FormFieldState<dynamic>? state;

  const PropertytPrefixFormFactory({
    Key? key,
    required this.onChanged,
    required this.displayName,
    required this.name,
    this.restOfAddress,
    this.value,
    this.state,
  }) : super(key: key);

  @override
  _PropertytPrefixFormFactoryState createState() =>
      _PropertytPrefixFormFactoryState();
}

class _PropertytPrefixFormFactoryState
    extends State<PropertytPrefixFormFactory> {
  Map<String, dynamic> _value = {};

  @override
  void initState() {
    _value = DataClassUtils.dynamicToMapStringDynamic(
      widget.value,
    );
    super.initState();
  }

  @override
  void didUpdateWidget(covariant PropertytPrefixFormFactory oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (_value != widget.value) {
      _value = DataClassUtils.dynamicToMapStringDynamic(
        widget.value,
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return BorderLabel(
      label: widget.displayName.length > 30
          ? widget.displayName.substring(0, 30) + "..."
          : widget.displayName,
      child: Row(
        children: [
          SizedBox(
            width: 50,
            child: TextFormFactory(
              value: _value[widget.name],
              displayName: widget.displayName,
              name: widget.name,
              onChanged: (String name, dynamic data) {
                widget.onChanged(widget.name, {..._value, widget.name: data});
              },
              showStandartBorder: false,
            ),
          ),
          Expanded(
            child: Text(widget.restOfAddress ?? ""),
          )
        ],
      ),
    );
  }
}
